AC_DEFUN([XORGAPPS_PREP_DIRS],dnl
  [dnl
    Capitols([DEFAULT_XORGDIRS_$1])="$2"
    $1_module_select=ALL
    AC_ARG_ENABLE([$1_modules], AC_HELP_STRING([--enable-$1-modules=list],
      [List of $1 modules to build @<:@default = ALL@:>@ available modules are - @<:@$2@:>@]),
      [
        case "$enableval" in
          no|NO|none|NONE)  $1_modules=""
                            $1_module_select=NONE ;;
          yes|YES|all|ALL)  $1_modules="$Capitols([DEFAULT_XORGDIRS_$1])" ;;
          *)                $1_modules="RTCommas2Spaces([$enableval])"
                            $1_module_select=SELECTED ;;
        esac
      ], [$1_modules="$Capitols([DEFAULT_XORGDIRS_$1])"])
    AC_ARG_WITH([system_$1], AC_HELP_STRING([--with-system-$1=list],
      [List of system $1 modules @<:@default = NONE@:>@ available modules are - @<:@$2@:>@]),
      [
        case "$withval" in
          no|NO|none|NONE)  system_$1="" ;;
          yes|YES|all|ALL)  system_$1="$Capitols([DEFAULT_XORGDIRS_$1])" ;;
          *)                system_$1="RTCommas2Spaces([$withval])" ;;
        esac
      ], [system_$1=""])

    for XORG_SUBDIR in $$1_modules ; do
      eval RTUnderscore([XBUILD_${XORG_SUBDIR}])=yes
    done
    for XORG_SUBDIR in $system_$1 ; do
      if eval test "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xyes" -o \
                   "x$$1_module_select" = "xALL" ; then
        eval RTUnderscore([XBUILD_${XORG_SUBDIR}])="sys"
      fi
    done
    for XORG_SUBDIR in $Capitols([DEFAULT_XORGDIRS_$1]) ; do
      if eval test "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xyes" -a \
                   "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xsys" ; then
        eval RTUnderscore([XBUILD_${XORG_SUBDIR}])=no
      fi
    done
    AC_CONFIG_COMMANDS_PRE([
      for XORG_SUBDIR in echo $Capitols([DEFAULT_XORGDIRS_$1]) ; do
        if eval test "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" = xyes ; then
          if test "$XORG_SUBDIR" = xbitmaps ; then
            XORG_SUBDIRS="$XORG_SUBDIR $XORG_SUBDIRS"
          else
            XORG_SUBDIRS="$XORG_SUBDIRS $XORG_SUBDIR"
          fi
        fi
      done
      XORG_OUTPUT_RESULTS([$1], [$2])
      AC_SUBST([XORG_SUBDIRS])])
  ])dnl

AC_DEFUN([XORGAPPS_OSCHECKS],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    case $host_os in
      linux*)            OS_CFLAGS="-D_XOPEN_SOURCE" ;;
      darwin*)           OS_CFLAGS="-D__DARWIN__ -DNO_LASTLOG" ;;
      *bsd*|dragonfly*)  OS_CFLAGS="-DCSRG_BASED" ;;
      *)                 OS_CFLAGS="" ;;
    esac
  ])

AC_DEFUN([XORGAPPS_CHECK_APPDEFS],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    if $PKG_CONFIG --exists xt ; then
      appdefaultdir=$($PKG_CONFIG --variable=appdefaultdir xt)
      XTHREADLIB=$($PKG_CONFIG --variable=xthreadlib x11)
      XHAVE_APPDEFAULTDIR=yes
    else
      XHAVE_APPDEFAULTDIR=no
    fi
    AC_SUBST([appdefaultdir])
    AC_SUBST([XTHREADLIB])
  ])

AC_DEFUN([XORGAPPS_XBITMAPS],dnl
  [dnl
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
    XORG_CHECK_PREREQ([xbitmaps],dnl
      [dnl
        XBITMAPS_CFLAGS="-I\$(top_srcdir)/xbitmaps/include"
        XBITMAPS_LIBS=""
        XORG_ENABLE_MODULE([xbitmaps])
      ],[dnl
        AC_MSG_CHECKING([for xbitmaps])
        if $PKG_CONFIG --exists xbitmaps ; then
          XBITMAPS_CFLAGS=$($PKG_CONFIG --cflags xbitmaps)
          XBITMAPS_LIBSS=$($PKG_CONFIG --libs xbitmaps)
          XORG_ENABLE_MODULE([xbitmaps], [sys])
        else
          XORG_DISABLE_MODULE([xbitmaps])
        fi
        if test "x$XBUILD_xbitmaps" = xsys ; then
          AC_MSG_RESULT([yes])
        else
          AC_MSG_RESULT([no])
        fi
      ])dnl
  ])dnl

AC_DEFUN([XORGAPPS_CHECK_SILENT],
  [
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])dnl
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
    ifelse([$2], [],
      [
        Capitols([$1_CFLAGS])="$3"
        Capitols([$1_LIBS])="$4"
        Underscore([XBUILD_$1])=yes
      ], [
        if $PKG_CONFIG --exists "$2" && test Underscore(["x$XBUILD_$1"]) != "xno"; then
          Capitols([$1_CFLAGS])="$($PKG_CONFIG --cflags "$2") $3"
          Capitols([$1_LIBS])="$($PKG_CONFIG --libs "$2") $4"
          Underscore([XBUILD_$1])=yes
        else
          Underscore([XBUILD_$1])=no
        fi
      ])dnl
    Capitols([AC_SUBST([$1_CFLAGS])])dnl
    Capitols([AC_SUBST([$1_LIBS])])dnl
  ])dnl

AC_DEFUN([XORGAPPS_CHECKP],
  [
    ifelse([$2], [], [AC_MSG_CHECKING([for $1 deps ])],
      [AC_MSG_CHECKING([for $1 deps - @<:@$2@:>@ ])])dnl
    XORGAPPS_CHECK_SILENT([$1], [$2], [$3], [$4])dnl
    AC_MSG_RESULT(Underscore([$XBUILD_$1]))
  ])

AC_DEFUN([XORGAPPS_CHECK],
  [
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])dnl
    XORG_CHECK_PREREQ([$1],[
    XORGAPPS_CHECKP([$1], [$2], [$3], [$4])dnl
    ])
  ])dnl

AC_DEFUN([XORGAPPS_CHECK_XAW_XPRINT],
  [
dnl This produces an error if not found - unsuitable
dnl    XAW_CHECK_XPRINT_SUPPORT(XAW)
dnl Lets bodgy up our own
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
    AC_ARG_ENABLE(xprint, AC_HELP_STRING([--enable-xprint], [Enable XPrint support]),
      [use_xprint=$enableval],[use_xprint=auto])
    if test "x$use_xprint" = "xyes"; then
      TMP_CHECK1=xaw8
      TMP_CHECK2=
      xaw_use_xprint=yes
    elif test "x$use_xprint" = "xno"; then
      TMP_CHECK1=xaw7
      TMP_CHECK2=
      xaw_use_xprint=no
    else
      TMP_CHECK1=xaw8
      TMP_CHECK2=xaw7
      xaw_use_xprint=yes
    fi
    XAW_MODULE=""
    if $PKG_CONFIG --exists $TMP_CHECK1 ; then
      XAW_MODULE="$TMP_CHECK1"
      success=yes
    else
      success=no
    fi
    if test "x$TMP_CHECK2" != "x" ; then
      if test $success = no ; then
        if $PKG_CONFIG --exists $TMP_CHECK2 ; then
          XAW_MODULE="$TMP_CHECK2"
          success=yes
        else
          success=no
        fi
        xaw_use_xprint=no
      fi
    fi
    AM_CONDITIONAL([XAW_USE_XPRINT], [test "x$xaw_use_xprint" = "xyes"])
    if test "x$success" = "xyes"; then
      XAW_CFLAGS=$($PKG_CONFIG --cflags $XAW_MODULE)
      XAW_LIBS=$($PKG_CONFIG --libs $XAW_MODULE)
      CHECK_XAW_XPRINT=yes
    else
      CHECK_XAW_XPRINT=no
    fi
  ])

AC_DEFUN([XORGAPPS_XPRINT_CHECK_SILENT],
  [
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])dnl
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])dnl
    if test "x$CHECK_XAW_XPRINT" = "xno" ; then
      Underscore([XBUILD_$1])=no
    else
      XORGAPPS_CHECK_SILENT([$1], [$2 $XAW_MODULE], [$3], [$4])dnl
    fi
  ])

AC_DEFUN([XORGAPPS_XPRINT_CHECK],
  [
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])dnl
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])dnl
    XORG_CHECK_PREREQ([$1], [
      ifelse([$2], [], [AC_MSG_CHECKING([for $1 deps - @<:@$XAW_MODULE@:>@])],
        [AC_MSG_CHECKING([for $1 deps - @<:@$2 $XAW_MODULE@:>@ ])])dnl
      XORGAPPS_XPRINT_CHECK_SILENT([$1], [$2], [$3], [$4])dnl
      AC_MSG_RESULT(Underscore([$XBUILD_$1]))
    ])
  ])dnl

AC_DEFUN([XORGAPPS_XPRINT_CHECKP],
  [
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])dnl
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])dnl
    ifelse([$2], [], [AC_MSG_CHECKING([for $1 deps - @<:@$XAW_MODULE@:>@])],
      [AC_MSG_CHECKING([for $1 deps - @<:@$2 $XAW_MODULE@:>@ ])])dnl
    XORGAPPS_XPRINT_CHECK_SILENT([$1], [$2], [$3], [$4])dnl
    AC_MSG_RESULT(Underscore([$XBUILD_$1]))
  ])dnl

AC_DEFUN([XORGAPPS_LOCALALIASFILE],
  [
    AC_ARG_WITH(localealiasfile,
      AC_HELP_STRING([--with-localealiasfile=<path>],
        [The locale alias file (default: ${libdir}/X11/locale/locale.alias)]),
      [LOCALEALIASFILE="$withval"],
      [LOCALEALIASFILE=${libdir}/X11/locale/locale.alias])
    AC_SUBST([LOCALEALIASFILE])
  ])

AC_DEFUN([XORGAPPS_CIDDIR],
  [
    AC_ARG_WITH(ciddir,
      AC_HELP_STRING([--with-ciddir=<path>],
        [Set default CID directory (default: ${libdir}/X11/fonts/CID)]),
      [DEFAULTCID="$withval"],
      [DEFAULTCID=${libdir}/X11/fonts/CID])
    AC_SUBST([DEFAULTCID])
  ])

AC_DEFUN([XORGAPPS_RGB_FILE],
  [
    XORG_CHECK_PREREQ([rgb], [
      AC_MSG_CHECKING([for rgb database location])
      AC_ARG_WITH([rgb-db-dir],
        AC_HELP_STRING([--with-rgb-db-dir=<path>],
           [rgb database location (default is ${datadir}/X11/rgb)]),
        [db_path=$withval], [db_path=${datadir}/X11/rgb])
      AC_MSG_RESULT([$db_path])
dnl XXX not working - AC_DEFINE([RGB_DB], $db_path, [set to location of rgb database (without any file type suffix)])
      db_file=`basename $db_path`
      db_dir=`dirname $db_path`
      AC_SUBST([db_file])
      AC_SUBST([db_dir])

      AC_MSG_CHECKING([for rgb database format])
      AC_ARG_WITH([rgb-db-type],
        AC_HELP_STRING([--with-rgb-db-type=(text|dbm|ndbm)],
          [rgb database type (default is text)]),
        [db_type=$withval], [db_type="text"])
      AC_MSG_RESULT([$db_type])

      case $db_type in
        text)  RGB_DB_FILES=""
               AC_DEFINE([USE_RGB_TXT], [1],
                 [Define to 1 to use plain text files for rgb database]) ;;
        dbm)   AC_SEARCH_LIBS([dbminit], [db dbm],  [],
                  AC_MSG_ERROR([dbm requested but dbminit() not found in any libraries]))
               RGB_DB_FILES="$(db_file).dir $(db_file).pag" ;;
        ndbm)  # Find a dbm or ndbm implementation
               AC_SEARCH_LIBS([dbm_open], [db ndbm dbm],
                 AC_DEFINE([NDBM], [1],
                   [Define to 1 if you have ndbm.h interfaces]),
                   AC_MSG_ERROR(
                     [ndbm requested but dbm_open() not found in any libraries]))
               RGB_DB_FILES="$(db_file).dir $(db_file).pag" ;;
      esac
      AC_SUBST([RGB_DB_FILES])
    ])
    AM_CONDITIONAL(RGB_TXT, [test x$db_type = xtext])
  ])

AC_DEFUN([XORGAPPS_DEFAULT_USERPATH],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    AC_ARG_WITH(default-user-path,  [  --with-default-user-path=PATH ],
      [ DEFAULT_USER_PATH="$withval" ],
      [ case $host_os in
          dragonfly*)     DEFAULT_USER_PATH="/bin:/usr/bin:/sbin:/usr/sbin:${bindir}:/usr/local/bin" ;;
          freebds*)       DEFAULT_USER_PATH="/bin:/usr/bin:/sbin:/usr/sbin:${bindir}:/usr/gnu/bin:/usr/local/bin" ;;
          netbsd*)        DEFAULT_USER_PATH="/bin:/usr/bin:/usr/pkg/bin:/usr/local/bin:${bindir}" ;;
          openbsd*|bsdi*) DEFAULT_USER_PATH="/bin:/usr/bin:/usr/local/bin/:${bindir}" ;;
          solaris*)       DEFAULT_USER_PATH="/usr/bin:${bindir}" ;;
          *)              DEFAULT_USER_PATH="/bin:/usr/bin:${bindir}:/usr/ucb:/usr/gnu/bin:/usr/local/bin" ;;
        esac ])
    AC_SUBST(DEFAULT_USER_PATH)
  ])

AC_DEFUN([XORGAPPS_DEFAULT_SYSTEMPATH],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    AC_ARG_WITH(default-system-path,  [  --with-default-system-path=PATH ],
      [ DEFAULT_USER_PATH="$withval" ],
      [ case $host_os in
          dragonfly*|freebds*) DEFAULT_SYSTEM_PATH="/bin:/usr/bin:/sbin:/usr/sbin:${bindir}" ;;
          *bsd*)               DEFAULT_SYSTEM_PATH="/sbin:/usr/sbin:/bin:/usr/bin:${bindir}" ;;
          solaris*)            DEFAULT_SYSTEM_PATH="/sbin:/usr/sbin:/usr/bin:${bindir}" ;;
          *)                   DEFAULT_SYSTEM_PATH="/etc:/bin:/usr/bin:${bindir}:/usr/ucb" ;;
        esac ])
    AC_SUBST(DEFAULT_SYSTEM_PATH)
  ])

AC_DEFUN([XORGAPPS_DEFAULT_MANPATH],
  [
    AC_ARG_WITH(default-man-path,  [  --with-default-man-path=PATH ],
      [ DEFAULT_X_MANPATH="$withval" ],
      [ DEFAULT_X_MANPATH="${prefix}/man:/usr/share/man:/usr/man" ])
    AC_SUBST(DEFAULT_X_MANPATH)
  ])

AC_DEFUN([XORGAPPS_XKB_CONFIG_ROOT],
  [
    AC_ARG_WITH(xkb-config-root,
      AC_HELP_STRING([--with-xkb-config-root=<paths>],
        [Set default XKB config root (default: ${datadir}/X11/xkb)]),
      [XKBCONFIGROOT="$withval"],
      [XKBCONFIGROOT=${datadir}/X11/xkb])
    AC_SUBST([XKBCONFIGROOT])
  ])

AC_DEFUN([XORGAPPS_XCLOCK],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])

    if test x$BUILD_xclock ; then
      XCLOCK_MODULES="x11 $XAW_MODULE"
      XCLOCK_F=""

      dnl Optional dependencies
      AC_ARG_WITH(xft, AC_HELP_STRING([--with-xclock-xft],
        [Use Xft2 and Xrender for rendering xclock (Default is YES)]),
        use_xft="$withval",use_xft="try")
      if test x$use_xft != xno ; then
        XFT_CFLAGS=$($PKG_CONFIG --cflags xrender xft)
        XFT_LIBS=$($PKG_CONFIG --libs xrender xft)
#        AC_SEARCH_LIBS(sqrt, [m])
        XCLOCK_MODULES="$XCLOCK_MODULES xft"
        AC_DEFINE([XRENDER],1,[Define to use X Render Extension])
        AC_DEFINE([XFREE86_FT2],1,[Define to use Xft2 library])
      fi
      AC_ARG_WITH(xkb, AC_HELP_STRING([--with-xclock-xkb],
        [Use XKB to sound xclock bells (Default is YES)]),use_xkb="$withval",
        use_xkb="try")
      if test x$use_xkb != xno ; then
        XKB_CFLAGS=$($PKG_CONFIG --cflags xkbfile)
        XKB_LIBS=$($PKG_CONFIG --libs xkbfile)
        XCLOCK_MODULES="$XCLOCK_MODULES xkbfile"
        XCLOCK_F="$XCLOCK_F -DXKB"
dnl        AC_DEFINE([XKB],1,[Define to use XkbStdBell])
      fi
      XORGAPPS_CHECKP([xclock], [$XCLOCK_MODULES], [$XCLOCK_F], [$MATH_LIBS])
    fi
  ])

AC_DEFUN([XORGAPPS_XDBEDIZZY],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])
    XORG_CHECK_PREREQ([xdbedizzy], [
      if test x$use_xprint = xyes ; then
        XDBEDIZZY_CFLAGS=$($PKG_CONFIG --cflags xext xprintutil xp xau)
        XDBEDIZZY_LIBS=$($PKG_CONFIG --libs xext xprintutil xp xau)
      else
        XDBEDIZZY_CFLAGS=$($PKG_CONFIG --cflags xext)
        XDBEDIZZY_LIBS=$($PKG_CONFIG --libs xext)
      fi
    ])
    AM_CONDITIONAL([USE_XPRINT], [test "$use_xprint" = yes])
    AC_SUBST(XDBEDIZZY_CFLAGS)
    AC_SUBST(XDBEDIZZY_LIBS)
  ])

AC_DEFUN([XORGAPPS_CHECK_PAM],
  [
# darwin could have PAM support, but not yet
    case $host_os in
      darwin*) use_pam_default=no  ;;
      *)       use_pam_default=try ;;
    esac

    XORG_CHECK_PREREQ([xdm], [
# Check for PAM support
      AC_ARG_WITH(pam, AC_HELP_STRING([--with-pam],[Use PAM for authentication]),
        [USE_PAM=$withval], [USE_PAM=$use_pam_default])
      if test "x$USE_PAM" != "xno" ; then
        AC_SEARCH_LIBS(pam_open_session,[pam])
        AC_CHECK_FUNC(pam_open_session,
          [AC_DEFINE(USE_PAM,1,[Use PAM for authentication])],
          [if test "x$USE_PAM" != "xtry" ; then
            AC_MSG_ERROR(
              ["PAM support requested, but pam_open_session not found."])
          fi])
      fi
    ])
  ])

AC_DEFUN([XORGAPPS_PROG_SU],
  [
    case $host_os in
      darwin*|*bsd*)  SU="su -m" ;;
      *)              SU="su" ;;
    esac
    AC_SUBST(SU)
  ])

AC_DEFUN([XORGAPPS_RANDOM_DEVICE],
  [
    AC_ARG_WITH(random-device,
      AC_HELP_STRING([--with-random-device\[=<pathname>\]],
        [Use <pathname> as a source of randomness]),
      RANDOM_DEVICE="$withval", RANDOM_DEVICE="try")

    if test x$RANDOM_DEVICE = xyes -o x$RANDOM_DEVICE = xtry ; then
      AC_CHECK_FILE([/dev/urandom], [RANDOM_DEVICE=/dev/urandom],
        AC_CHECK_FILE([/dev/random], [RANDOM_DEVICE=/dev/random]))
      if test x$RANDOM_DEVICE = xyes ; then
        AC_MSG_ERROR(
          ["random device support requested, but no random device was found."])
      else
        if test x$RANDOM_DEVICE = xtry ; then
          RANDOM_DEVICE="no"
        fi
      fi
    fi

    if test x$RANDOM_DEVICE != xno ; then
      AC_DEFINE_UNQUOTED(DEV_RANDOM,"$RANDOM_DEVICE",
        [Define to device that provides random data source])
      RANDOMMANDEFS="$RANDOMMANDEFS -DDEV_RANDOM=\\\"$RANDOM_DEVICE\\\""
    fi

    AC_CHECK_FUNC(arc4random, [HAS_ARC4_RANDOM="yes"], [HAS_ARC4_RANDOM="no"])
    AM_CONDITIONAL(HAS_ARC4_RANDOM, test x$HAS_ARC4_RANDOM = xyes)
    if test x$HAS_ARC4_RANDOM = xyes ; then
      AC_DEFINE(ARC4_RANDOM, 1, [Define to use arc4random() function])
      RANDOMMANDEFS="$RANDOMMANDEFS -DARC4_RANDOM"
    fi

    AC_SUBST(RANDOMMANDEFS)
  ])

AC_DEFUN([XORGAPPS_XDM_DIRS],
  [
    XORG_CHECK_PREREQ([xdm], [
      AC_ARG_WITH(xdmlibdir,
        AC_HELP_STRING([--with-xdmlibdir=<pathname>],
          [specify directory for xdm scripts and modules (default=${libdir}/X11/xdm)]),
        [XDMLIBDIR="$withval"], [XDMLIBDIR="${libdir}/X11/xdm"])
      AC_SUBST(XDMLIBDIR)

      AC_ARG_WITH(xdmconfigdir,
        AC_HELP_STRING([--with-xdmconfigdir=<pathname>],
          [specify directory for xdm config files (default is same as xdmlibdir)]),
        [XDMCONFIGDIR="$withval"], [XDMCONFIGDIR="${XDMLIBDIR}"])
      AC_SUBST(XDMCONFIGDIR)

      AC_ARG_WITH(xdmscriptdir,
        AC_HELP_STRING([--with-xdmscriptdir=<pathname>],
          [specify directory for xdm scripts (default is same as xdmlibdir)]),
        [XDMSCRIPTDIR="$withval"], [XDMSCRIPTDIR="${XDMLIBDIR}"])
      AC_SUBST(XDMSCRIPTDIR)

      AC_ARG_WITH(logdir,
        AC_HELP_STRING([--with-logdir=<pathname>],
          [specify directory for xdm log files (default=/var/log)]),
        [XDMLOGDIR="$withval"], [XDMLOGDIR="/var/log"])
      AC_SUBST(XDMLOGDIR)

      AC_ARG_WITH(piddir,
        AC_HELP_STRING([--with-piddir=<pathname>],
          [specify directory for xdm pid files (default=/var/run)]),
        [XDMPIDDIR="$withval"], [XDMPIDDIR="/var/run"])
      AC_SUBST(XDMPIDDIR)

      AC_ARG_WITH(default-vt,
        AC_HELP_STRING([--with-default-vt=<vtname>],
          [specify default vt to start xdm on (default=none)]),
        [DEFAULTVT="$withval"], [[DEFAULTVT=""]])
      AC_SUBST(DEFAULTVT)

      AC_ARG_WITH(config-type,
        AC_HELP_STRING([--with-config-type={ws|fs}],
         [default config file type to use - workstation (ws) or fileserver (fs) (default=ws)]),
        [SERVERSTYPE="$withval"], [SERVERSTYPE="ws"])
      AC_SUBST(SERVERSTYPE)
    ])
  ])

AC_DEFUN([XORGAPPS_PROG_SHELL],
  [
    case $host_os in
      *sco*|*solaris*) SHELL_CMD="/bin/ksh"    ;;
      *)               SHELL_CMD="/bin/sh"     ;;
    esac
    AC_SUBST(SHELL_CMD)
  ])

AC_DEFUN([XORGAPPS_XDM],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])

    XORG_SET_PREREQ([xdm], [xdmgreet chooser xdmshell])
    XORG_CHECK_PREREQ([xdm], [
      AC_ARG_WITH(color-pixmap,
        AC_HELP_STRING([--with-color-pixmap=<filename>],
          [specify xpm file to use as color logo (default=xorg.xpm)]),
        [XDM_PIXMAP="$withval"], [XDM_PIXMAP="xorg.xpm"])
      AC_ARG_WITH(bw-pixmap,
        AC_HELP_STRING([--with-bw-pixmap=<filename>],
      [specify xpm file to use as black-and-white logo (default=xorg-bw.xpm)]),
        [XDM_BWPIXMAP="$withval"], [XDM_BWPIXMAP="xorg-bw.xpm"])
      AC_ARG_WITH(pixmapdir,
        AC_HELP_STRING([--with-pixmapdir=<pathname>],
        [specify directory for xpm files (default=xdmlibdir/pixmaps)]),
        [XDM_PIXMAPDIR="$withval"],
        [XDM_PIXMAPDIR='${XDMLIBDIR}/pixmaps'])

      AC_SUBST(XDM_PIXMAP)
      AC_SUBST(XDM_BWPIXMAP)
      AC_SUBST(XDM_PIXMAPDIR)

      XDM_MODULES="xmu x11 xau xdmcp"
      XDM_GREET_MODULES=""
      CHOOSER_MODULES="x11 xdmcp xau"
      XDMSHELL_MODULES="xmu x11 xau xdmcp xt"
      if $PKG_CONFIG --exists xinerama ; then
        AC_DEFINE([USE_XINERAMA], 1,
          [Define to 1 to use XINERAMA in greeter & chooser])
        XINERAMA_MODULES="xinerama"
      else
        XINERAMA_MODULES=""
      fi
      AC_ARG_ENABLE(xpm-logos,
        AC_HELP_STRING([--enable-xpm-logos],
          [Display xpm logos in greeter (default is YES)]),
        [USE_XPM="$enableval"],
        [ if $PKG_CONFIG --exists xpm ; then 
            USE_XPM="yes"
          else
            USE_XPM="no"
          fi])
      if test "x$USE_XPM" = "xyes" ; then
        AC_DEFINE([XPM], 1,
          [Define to 1 to display XPM logos on greeter screen])
        XPM_MODULES="xpm"
      else
        XPM_MODULES=""
      fi

      AC_MSG_CHECKING([if the greeter should be built as a dynamically loaded shared object])
      AC_ARG_ENABLE(dynamic-greeter,
        AC_HELP_STRING([--enable-dynamic-greeter],
          [Build greeter as dynamically loaded shared object]),
        [DYNAMIC_GREETER="$enableval"], [DYNAMIC_GREETER="auto"])
      if test "x$DYNAMIC_GREETER" = "xauto" ; then
        case $host_os in
          *)  DYNAMIC_GREETER="yes" ;;
        esac
      fi
      AC_MSG_RESULT([$DYNAMIC_GREETER])
      if test "x$DYNAMIC_GREETER" = "xyes" ; then
        GREETER_CFLAGS="$GREETER_CFLAGS -DGREET_LIB"
        if test "x$GCC" = "xyes"; then
          XDM_LDFLAGS="$XDM_LDFLAGS -rdynamic"
        fi
        AC_MSG_CHECKING([for xdmgreeter deps - @<:@xt x11 xext xau xdmcp $XPM_MODULES $XINERAMA_MODULES@:>@])
        XORGAPPS_XPRINT_CHECK_SILENT([xdmgreet],
          [xt x11 xext xau xdmcp $XPM_MODULES $XINERAMA_MODULES],
          ["-DGREET_LIB"])
        AC_MSG_RESULT(Underscore([$XBUILD_xdmgreet]))
        GREETERLIB="${XDMLIBDIR}/libXdmGreet.so"
        AC_DEFINE_DIR(DEF_GREETER_LIB, GREETERLIB,
          [Location of Xdm Greeter library])
      else
        XDM_GREET_MODULES="xext"
        XDM_GREET_FLAGS="$XAW_CFLAGS -DGREET_USER_STATIC"
        XDM_GREET_LBS="$XAW_LIBS"
      fi

      XORGAPPS_CHECKP([xdm],
        [$XDM_MODULES $XDM_GREET_MODULES $XPM_MODULES $XINERAMA_MODULES],
        [$XDM_GREET_FLAGS $OS_CFLAGS],[$XDM_GREET_LBS])

      AC_MSG_CHECKING([for xdmchooser deps - @<:@$CHOOSER_MODULES $XINERAMA_MODULES@:>@])
      XORGAPPS_XPRINT_CHECK_SILENT([chooser],
        [$CHOOSER_MODULES $XINERAMA_MODULES],[-D_BSD_SOURCE])
      AC_MSG_RESULT(Underscore([$XBUILD_chooser]))

      XORGAPPS_XPRINT_CHECK([xdmshell],
        [$XDMSHELL_MODULES $XDM_GREET_MODULES $XPM_MODULES $XINERAMA_MODULES],
        [$XDM_GREET_FLAGS $OS_CFLAGS])
      AC_CHECK_LIB([Xdmcp], [XdmcpWrap], [xdmauth="yes"], [xdmauth="no"],
        [$DMCP_LIBS])
      AC_SEARCH_LIBS([crypt], [crypt])
      XORG_XBUILD_CHECK([xdmgreet chooser xdmshell],,[XORG_DISABLE_MODULE([xdm])
        AC_MSG_WARN([xdm not being made due to failed dependancies])])
    ])
    AM_CONDITIONAL(USE_XPM, test "x$USE_XPM" = "xyes")
    AM_CONDITIONAL(DYNAMIC_GREETER, test x$DYNAMIC_GREETER = xyes)
    AM_CONDITIONAL(HAS_XDM_AUTH, test x$xdmauth = xyes)
 ])

AC_DEFUN([XORGAPPS_XDM_SESSION],
  [
    AC_REQUIRE([XORGAPPS_DEFAULT_USERPATH])
    AC_REQUIRE([XORGAPPS_DEFAULT_SYSTEMPATH])
    XORG_CHECK_PREREQ([xdm], [
      # -DDEF_SERVER_LINE=":0 local $(DEF_SERVER) :0"
      test -z "$DEF_SERVER"      && DEF_SERVER="${bindir}/X"
      test -z "$DEF_SERVER_LINE" && DEF_SERVER_LINE=":0 local ${DEF_SERVER} :0"
      AC_DEFINE_DIR(DEF_SERVER_LINE, DEF_SERVER_LINE,
        [Define to default Xserver file entry for local X server])

      # -DXRDB_PROGRAM="$(BINDIR)/xrdb"
      AC_DEFINE_DIR(XRDB_PROGRAM, bindir/xrdb,
        [Define to pathname for xrdb program])

      # -DDEF_SESSION="$(BINDIR)/xterm -ls"
      AC_DEFINE_DIR(DEF_SESSION, bindir/xterm -ls,
        [Define to default command to start X session])

      AC_DEFINE_DIR([DEF_USER_PATH], [DEFAULT_USER_PATH],
        [Define to default PATH environment variable for the user sessions])
      AC_DEFINE_DIR([DEF_SYSTEM_PATH], [DEFAULT_SYSTEM_PATH],
        [Define to default PATH environment variable for system commands])

      # -DDEF_SYSTEM_SHELL="$(BOURNE_SHELL)"
      test -z "$BOURNE_SHELL" && BOURNE_SHELL=/bin/sh
      AC_DEFINE_DIR(DEF_SYSTEM_SHELL, BOURNE_SHELL,
        [Define to default shell])

      # -DDEF_FAILSAFE_CLIENT="$(BINDIR)/xterm"
      AC_DEFINE_DIR(DEF_FAILSAFE_CLIENT, bindir/xterm,
        [Define to default command to start failsafe X session])

      # -DDEF_XDM_CONFIG="$(XDMDIR)/xdm-config"
      AC_DEFINE_DIR(DEF_XDM_CONFIG, XDMCONFIGDIR/xdm-config,
        [Define to pathname of default xdm-config file])

      # -DDEF_CHOOSER="$(CHOOSERPATH)"
      AC_DEFINE_DIR(DEF_CHOOSER, XDMLIBDIR/chooser,
        [Define to pathname of where chooser binary is installed])

      # -DDEF_AUTH_DIR="$(XDMDIR)"
      AC_DEFINE_DIR(DEF_AUTH_DIR, XDMCONFIGDIR,
        [Define to pathname where authentication cookie files should be stored])

      # -DDEF_GREETER_LIB="$(XDMDIR)/libXdmGreet.so"
      AC_DEFINE_DIR(DEF_GREETER_LIB, XDMLIBDIR/libXdmGreet.so,
        [Define to pathname where greeter shared object is installed (if used)])
    ])
  ])

dnl From http://autoconf-archive.cryp.to/ac_define_dir.html.
AC_DEFUN([AC_DEFINE_DIR], [
  prefix_NONE=
  exec_prefix_NONE=
  test "x$prefix" = xNONE && prefix_NONE=yes && prefix=$ac_default_prefix
  test "x$exec_prefix" = xNONE && exec_prefix_NONE=yes && exec_prefix=$prefix
  eval ac_define_dir="\"[$]$2\""
  AC_SUBST($1, "$ac_define_dir")
  AC_DEFINE_UNQUOTED($1, "$ac_define_dir", [$3])
  test "$prefix_NONE" && prefix=NONE
  test "$exec_prefix_NONE" && exec_prefix=NONE
])

AC_DEFUN([XORGAPPS_XDPYINFO],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])

    XORG_CHECK_PREREQ([xdpyinfo], [
      XORGAPPS_CHECKP([xdpyinfo], [xext x11 xtst])
      DPY_X11_CFLAGS=$($PKG_CONFIG --cflags x11)
      DPY_X11_LIBS=$($PKG_CONFIG --libs x11)

      if $PKG_CONFIG --exists xext ; then
        XORGAPPS_CHECK_SILENT([DPY_XEXT], [xext])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XEXT_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/multibuf.h X11/extensions/XShm.h],,,
          [#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists x11 ; then
        XORGAPPS_CHECK_SILENT([DPY_XKB], [x11])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XKB_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/XKB.h X11/XKBlib.h],,,
          [#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xxf86vm ; then
        XORGAPPS_CHECK_SILENT([DPY_XF86VIDMODE], [xxf86vm])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XF86VIDMODE_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS(
          [X11/extensions/xf86vmode.h X11/extensions/xf86vmstr.h],,,
          [#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xxf86dga ; then
        XORGAPPS_CHECK_SILENT([DPY_XF86DGA], [xxf86dga])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XF86DGA_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS(
          [X11/extensions/xf86dga.h X11/extensions/xf86dgastr.h],,,
          [#include <X11/Xlib.h>
#include <X11/Xproto.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xxf86misc ; then
        XORGAPPS_CHECK_SILENT([DPY_XF86MISC], [xxf86misc])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XF86MISC_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS(
          [X11/extensions/xf86misc.h X11/extensions/xf86mscstr.h],,,
          [#include <X11/Xlib.h>
#include <X11/Xproto.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xi ; then
        XORGAPPS_CHECK_SILENT([DPY_XINPUT], [xi])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XINPUT_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/XInput.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xrender ; then
        XORGAPPS_CHECK_SILENT([DPY_XRENDER], [xrender])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XRENDER_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/Xrender.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xinerama ; then
        XORGAPPS_CHECK_SILENT([DPY_XINERAMA], [xinerama])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XINERAMA_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/Xinerama.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists dmx ; then
        XORGAPPS_CHECK_SILENT([DPY_DMX], [dmx])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_DMX_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/dmxext.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xp ; then
        XORGAPPS_CHECK_SILENT([DPY_XPRINT], [xp])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XPRINT_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/Print.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xtst ; then
        XORGAPPS_CHECK_SILENT([DPY_XTST], [xtst])
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPPFLAGS="$CPPFLAGS $DPY_XTST_CFLAGS $DPY_X11_CFLAGS"
        AC_CHECK_HEADERS([X11/extensions/record.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi
    ])
  ])

AC_DEFUN([XORGAPPS_XEDIT],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    AC_REQUIRE([XORGAPPS_CHECK_APPDEFS])
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])
    XEDIT_MODULES="$XAW_MODULE"
    if test "x$xaw_use_xprint" = "xyes" ; then
      XEDIT_MODULES="$XEDIT_MODULES xprintutil xp"
    fi
    XORGAPPS_CHECK([xedit], [$XEDIT_MODULES])
  ])

AC_DEFUN([XORGAPPS_XINIT],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    AC_REQUIRE([XORGAPPS_PROG_SHELL])

    XORG_CHECK_PREREQ([xinit], [
      DEFAULT_XRDB=xrdb
      DEFAULT_XMODMAP=xmodmap
      DEFAULT_TWM=twm
      DEFAULT_XCLOCK=xclock
      DEFAULT_XTERM=xterm
# You always want to specify the full path to the X server
      DEFAULT_XSERVER=${bindir}/X
      DEFAULT_XAUTH=xauth
      DEFAULT_XINIT=xinit

      AC_ARG_WITH(xrdb, AS_HELP_STRING([--with-xrdb=XRDB], [Path to xrdb]),
        [XRDB="$withval"], [XRDB="$DEFAULT_XRDB"])

      AC_ARG_WITH(xmodmap,
         AS_HELP_STRING([--with-xmodmap=XMODMAP], [Path to xmodmap]),
        [XMODMAP="$withval"], [XMODMAP="$DEFAULT_XMODMAP"])

      AC_ARG_WITH(twm, AS_HELP_STRING([--with-twm=TWM], [Path to twm]),
        [TWM="$withval"], [TWM="$DEFAULT_TWM"])

      AC_ARG_WITH(xclock,
        AS_HELP_STRING([--with-xclock=XCLOCK], [Path to xclock]),
        [XCLOCK="$withval"], [XCLOCK="$DEFAULT_XCLOCK"])

      AC_ARG_WITH(xterm, AS_HELP_STRING([--with-xterm=XTERM], [Path to xterm]),
        [XTERM="$withval"], [XTERM="$DEFAULT_XTERM"])

      AC_ARG_WITH(xserver,
        AS_HELP_STRING([--with-xserver=XSERVER], [Path to default X server]),
        [XSERVER="$withval"], [XSERVER="$DEFAULT_XSERVER"])

      AC_ARG_WITH(xauth, AS_HELP_STRING([--with-xauth=XAUTH], [Path to xauth]),
        [XAUTH="$withval"], [XAUTH="$DEFAULT_XAUTH"])

      AC_ARG_WITH(xinit, AS_HELP_STRING([--with-xinit=XINIT], [Path to xinit]),
        [XINIT="$withval"], [XINIT="$DEFAULT_XINIT"])

      case $host_os in
        *bsd*) XINIT_EFLAGS="-DCSRG_BASED" ;;
      esac
      XORGAPPS_CHECKP([xinit], [x11], [$XINIT_EFLAGS])

      AC_PATH_PROGS(MCOOKIE, [mcookie], [$MCOOKIE],
        [$PATH:/bin:/usr/bin:/usr/lib:/usr/libexec:/usr/local/bin])
      if test x$MCOOKIE != x ; then
        STARTX_COOKIE_FLAGS='-DHAS_COOKIE_MAKER -DMK_COOKIE=$(MCOOKIE)'
      fi
      AC_SUBST(STARTX_COOKIE_FLAGS)

      case $host_os in
        *sco*) ARCHMANDEFS="-D__SCOMAN__" ;;
        *)     ARCHMANDEFS="" ;;
      esac
    ])
    AC_SUBST(ARCHMANDEFS)
    AC_SUBST(XRDB)
    AC_SUBST(XMODMAP)
    AC_SUBST(TWM)
    AC_SUBST(XCLOCK)
    AC_SUBST(XTERM)
    AC_SUBST(XSERVER)
    AC_SUBST(XAUTH)
    AC_SUBST(XINIT)

    AC_DEFINE(XORG, 1, [Define if you have Xorg X server])
  ])

AC_DEFUN([XORGAPPS_X11PERF],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    XORGAPPS_CHECK([x11perf], [x11 xmuu])
    if test x$XBUILD_x11perf = yes ; then
      if $PKG_CONFIG --exists xrender ; then
        XORGAPPS_CHECK_SILENT([XRENDER], [xrender])
        AC_DEFINE(XRENDER,1,[Xrender library available])
      fi
      if $PKG_CONFIG --exists xft ; then
        XORGAPPS_CHECK_SILENT([XFT], [xft])
        AC_DEFINE(XFT,1,[Xft library available])
      fi
      if $PKG_CONFIG --exists xext ; then
        XORGAPPS_CHECK_SILENT([XEXT], [xrender])
        save_LIBS="$LIBS"
        LIBS="$XEXT_LIBS $LIBS"
        AC_CHECK_FUNCS([XShmQueryExtension],
          AC_DEFINE(MITSHM, 1, [MIT-SHM extension available]))
        LIBS="$save_LIBS"
      fi
    fi
  ])

AC_DEFUN([XORGAPPS_IMAKE],
  [
    AC_REQUIRE([XORG_PROG_RAWCPP])
    CPP_PROGRAM=${RAWCPP}
    AC_SUBST(CPP_PROGRAM)

    DEFAULT_XCONFDIR="${libdir}/X11/config"
    AC_ARG_WITH(config-dir,
      AS_HELP_STRING([--with-config-dir=<path>], [Path to config dir (default: ${libdir}/X11/config)]),
      [XCONFDIR="$withval"], [XCONFDIR="$DEFAULT_XCONFDIR"])
    AC_SUBST(XCONFDIR)

    DEFAULT_PREPROCESSCMD_MKDEPEND="gcc -E"
    AC_ARG_WITH(script-preproc-cmd,
      AS_HELP_STRING([--with-script-preproc-cmd=CMD], [Preprocessor command to run on scripts (default: "gcc -E")]),
      [PREPROCESSCMD_MKDEPEND="$withval"],
      [PREPROCESSCMD_MKDEPEND="$DEFAULT_PREPROCESSCMD_MKDEPEND"])
    AC_SUBST(PREPROCESSCMD_MKDEPEND)

    DEFAULT_ARCMD="ar clq"
    AC_ARG_WITH(create-lib-cmd,
      AS_HELP_STRING([--with-create-lib-cmd=CMD], [Command to create libraries (default: "ar clq")]),
      [ARCMD="$withval"], [ARCMD="$DEFAULT_ARCMD"])
    AC_SUBST(ARCMD)

    DEFAULT_RANLIB="ranlib"
    AC_ARG_WITH(clean-lib-cmd,
      AS_HELP_STRING([--with-clean-lib-cmd=CMD], [Command to clean up libraries (default: "ranlib")]),
      [RANLIB="$withval"], [RANLIB="$DEFAULT_RANLIB"])
    AC_SUBST(RANLIB)

    AC_ARG_ENABLE(revpath,
      AS_HELP_STRING([--disable-revpath], [Build revpath (default: enabled)]),
      [BUILD_REVPATH="$enableval"], [BUILD_REVPATH=yes])
    AM_CONDITIONAL([BUILD_REVPATH], [test "x$BUILD_REVPATH" = xyes])

    AC_ARG_ENABLE(makeg,
      AS_HELP_STRING([--disable-makeg], [Build makeg (default: enabled)]),
      [BUILD_MAKEG="$enableval"], [BUILD_MAKEG=yes])
    AM_CONDITIONAL([BUILD_MAKEG], [test "x$BUILD_MAKEG" = xyes])

    AC_ARG_ENABLE(xmkmf,
      AS_HELP_STRING([--disable-xmkmf], [Build xmkmf (default: enabled)]),
      [BUILD_XMKMF="$enableval"], [BUILD_XMKMF=yes])
    AM_CONDITIONAL([BUILD_XMKMF], [test "x$BUILD_XMKMF" = xyes])

    AC_ARG_ENABLE(ccmakedep,
      AS_HELP_STRING([--disable-ccmakedep], [Build ccmakedep (default: enabled)]),
      [BUILD_CCMAKEDEP="$enableval"], [BUILD_CCMAKEDEP=yes])
    AM_CONDITIONAL([BUILD_CCMAKEDEP], [test "x$BUILD_CCMAKEDEP" = xyes])

    AC_ARG_ENABLE(mergelib,
      AS_HELP_STRING([--disable-mergelib], [Build mergelib (default: enabled)]),
      [BUILD_MERGELIB="$enableval"], [BUILD_MERGELIB=yes])
    AM_CONDITIONAL([BUILD_MERGELIB], [test "x$BUILD_MERGELIB" = xyes])

    AC_ARG_ENABLE(mkdirhier,
      AS_HELP_STRING([--disable-mkdirhier], [Build mkdirhier (default: enabled)]),
      [BUILD_MKDIRHIER="$enableval"], [BUILD_MKDIRHIER=yes])
    AM_CONDITIONAL([BUILD_MKDIRHIER], [test "x$BUILD_MKDIRHIER" = xyes])

    AC_ARG_ENABLE(cleanlinks,
      AS_HELP_STRING([--disable-cleanlinks], [Build cleanlinks (default: enabled)]),
      [BUILD_CLEANLINKS="$enableval"], [BUILD_CLEANLINKS=yes])
    AM_CONDITIONAL([BUILD_CLEANLINKS], [test "x$BUILD_CLEANLINKS" = xyes])

    AC_ARG_ENABLE(mkhtmlindex,
      AS_HELP_STRING([--disable-mkhtmlindex], [Build mkhtmlindex (default: enabled)]),
      [BUILD_MKHTMLINDEX="$enableval"], [BUILD_MKHTMLINDEX=yes])
    AM_CONDITIONAL([BUILD_MKHTMLINDEX], [test "x$BUILD_MKHTMLINDEX" = xyes])
  ])

AC_DEFUN([XORGAPPS_XLOGO],
  [
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    XLOGO_MODULES=""
    AC_ARG_WITH(render,
      AC_HELP_STRING([--with-xrender], [Use Xrender & Xft2 to draw logo]),
      USE_RENDER="$withval", USE_RENDER="try")
    if test "x$xaw_use_xprint" = "xyes" ; then
      XLOGO_MODULES="xprintutil xp"
    fi

    if test "x$USE_RENDER" = "xtry" && $PKG_CONFIG --exists xrender xft ; then
      USE_RENDER="yes"
    else
      USE_RENDER="no"
    fi
    if test "x$USE_RENDER" = "xyes" ; then
      XLOGO_MODULES="$XLOGO_MODULES xrender xft"
      AC_DEFINE(XRENDER, 1, [Define to 1 to use Xrender & Xft2 to draw logo])
    fi
    XORGAPPS_XPRINT_CHECK([xlogo], [xext $XLOGO_MODULES])
  ])

AC_DEFUN([XORGAPPS_XMAN],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])

    XORG_CHECK_PREREQ([xman], [
      AC_ARG_WITH(helpdir,
        AC_HELP_STRING([--with-helpdir=<path>],
          [Set default directory for xman.help (default: ${datadir}/X11)]),
        [HELPDIR="$withval"],
        [HELPDIR=${datadir}/X11])
      AC_SUBST([HELPDIR])

      AC_ARG_WITH(sysmanpath,
        AC_HELP_STRING([--with-sysmanpath=<path>],
          [Set default system man page search path]),
        [SYSMANPATH="$withval"], [])
      if test x$SYSMANPATH != x; then
        AC_DEFINE_UNQUOTED(SYSMANPATH, "$SYSMANPATH", 
  	[Default system man page search path (default: none)])
      fi

      AC_ARG_WITH(localmanpath,
        AC_HELP_STRING([--with-localmanpath=<path>],
          [Set default local man page search path]),
        [LOCALMANPATH="$withval"], [])
      if test x$LOCALMANPATH != x; then
        AC_DEFINE_UNQUOTED(LOCALMANPATH, "$LOCALMANPATH", 
  	[Default local man page search path (default: none)])
      fi

    # Check for man page config files
      AC_CHECK_FILE([/etc/man.conf], [MANCONF="/etc/man.conf"], 
        AC_CHECK_FILE([/etc/man.config], [MANCONF="/etc/man.config"], 
  	AC_CHECK_FILE([/etc/manpath.config], [MANCONF="/etc/manpath.config"])))
	
      if test x$MANCONF != x ; then
        AC_DEFINE_UNQUOTED(MANCONF, "$MANCONF", 
  	[Define to path to man config file if you have one])

        # Try to determine format of config file
        # would be better to somehow determine from the files themselves, but
        # we'll guess based on pathname and OS for now (mirrors old Imake tests)
        AC_MSG_CHECKING([man config file format])
        if test x$MANCONF = x/etc/manpath.config ; then
  	MAN_CONFIG_STYLE="FreeBSD"
          AC_DEFINE([MANCONFIGSTYLE_FreeBSD],1,
            [Define to 1 if you have FreeBSD format manpath.config])
        else
  	case $host_os in
  	*darwin* | *openbsd* | *netbsd* )
  	    MAN_CONFIG_STYLE="OpenBSD"
              AC_DEFINE([MANCONFIGSTYLE_OpenBSD],1,
                [Define to 1 if you have OpenBSD format manpath.config])
  	    ;;
      	*linux* )
  	    MAN_CONFIG_STYLE="Linux"
              AC_DEFINE([MANCONFIGSTYLE_Linux],1,
                [Define to 1 if you have Linux format man.conf or man.config])
  	    ;;
          *bsd* )
  	    MAN_CONFIG_STYLE="BSD"
              AC_DEFINE([MANCONFIGSTYLE_BSD],1,
                [Define to 1 if you have BSD format manpath.config])
  	    ;;
  	*)
  	    AC_MSG_ERROR([Could not determine man page file config format.])
  	    ;;
  	esac
        fi
        AC_MSG_RESULT($MAN_CONFIG_STYLE)
      fi

      XMAN_MODULES=""
      if test "x$xaw_use_xprint" = "xyes" ; then
        XMAN_MODULES="xprintutil xp"
      fi
      XORGAPPS_XPRINT_CHECK([xman], [$XMAN_MODULES])
    ])
  ])

AC_DEFUN([XORGAPPS_XMORE],
  [
    AC_REQUIRE([XORGAPPS_CHECK_XAW_XPRINT])
    XMORE_MODULES=""
    if test "x$xaw_use_xprint" = "xyes" ; then
      XMORE_MODULES="xprintutil xp"
    fi
    XORGAPPS_XPRINT_CHECK([xmore], [$XMORE_MODULES])
  ])

AC_DEFUN([XORGAPPS_CF_FILES],
  [
    DEFAULT_XCONFDIR="${libdir}/X11/config"
    AC_ARG_WITH(config-dir,
      AS_HELP_STRING([--with-config-dir=<path>], [Path to config dir (default: ${libdir}/X11/config)]),
      [XCONFDIR="$withval"], [XCONFDIR="$DEFAULT_XCONFDIR"])
    AC_SUBST(XCONFDIR)
  ])

AC_DEFUN([XORGAPPS_XPHELLOWORLD],
  [
    AC_REQUIRE([PKG_PROG_PKG_CONFIG])
    XORG_CHECK_PREREQ([xphelloworld], [
      build_motifapps=yes
      AC_ARG_WITH(motif-libraries, [Directory containing the Motif libraries], 
        motif_libs=$withval)
      AC_ARG_WITH(motif-includes, [Directory containing the Xm direcotry with the Motif header files (eg. /usr/X11R6/include)],
        motif_includes=$withval)
      if test x$with_motif_libraries = xno; then
        echo no motif - commandline  $with_motif_libraries
        build_motifapps=no
      fi
      if test -z $motif_libs && test x$build_motifapps != "xno" ; then
#        PKG_CHECK_MODULES(X11, x11)
        X11_CFLAGS=$($PKG_CONFIG --cflags x11)
        X11_LIBS=$($PKG_CONFIG --libs x11)
        AC_CHECK_LIB(Xm, XmFontListCreate, , [build_motifapps=no
        echo motif library not found
        build_motifapps=no ], [$X11])
      fi
      if test x$build_motifapps = xyes ; then
        if [[ ! -z $motif_includes ]] ; then
          MOTIF_CFLAGS=-I$motif_includes
        fi
        if [[ ! -z $motif_libs ]] ; then
          MOTIF_LIBS="-L$motif_libs -lXm"
        else
          MOTIF_LIBS="-lXm"
        fi
      fi
      echo build: Build Motif Applications: $build_motifapps

      # xpawhelloworld
      #
      if test x$build_motifapps = xyes ; then
        XPAWHELLOWORLD_CFLAGS="$($PKG_CONFIG --cflags xaw8 xprintutil xp) $MOTIF_CFLAGS"
        XPAWHELLOWORLD_LIBS="$($PKG_CONFIG --libs xaw8 xprintutil xp) $MOTIF_LIBS"
      fi
      AC_SUBST(XPAWHELLOWORLD_CFLAGS)
      AC_SUBST(XPAWHELLOWORLD_LIBS)

      #
      # xphelloworld
      #
      XORGAPPS_CHECKP([xphelloworld], [xprintapputil xprintutil xp])

      #
      # xpsimplehelloworld
      #
      XORGAPPS_CHECKP([xpsimplehelloworld], [xprintutil xp])

      #
      # xpxmhellowolrd
      #
      if test x$build_motifapps = xyes ; then
        XPXMHELLOWORLD_CFLAGS="$($PKG_CONFIG --cflags xprintutil xt xp) $MOTIF_CFLAGS"
        XPXMHELLOWORLD_LIBS="$($PKG_CONFIG --libs xprintutil xt xp) $MOTIF_LIBS"
      fi
      AC_SUBST([XPXMHELLOWORLD_CFLAGS])
      AC_SUBST([XPXMHELLOWORLD_LIBS])

      #
      # xpxthelloworld
      #
      XORGAPPS_CHECKP([xpxthelloworld], [xaw8 xprintutil xt xp])
    ])
    AM_CONDITIONAL([BUILD_MOTIFAPPS], test "$build_motifapps" = yes)
  ])

AC_DEFUN([XORGAPPS_XRDB],
  [
    XORG_CHECK_PREREQ([xrdb], [
      # Find MAXHOSTNAMELEN definition
      # Common hidey holes:
      #  BSD & Linux - <sys/param.h>
      #  Solaris - <netdb.h>
      AC_CHECK_DECL([MAXHOSTNAMELEN],[FOUND_MAXHOSTNAMELEN=yes])
      if test x$FOUND_MAXHOSTNAMELEN != xyes ; then
        AC_MSG_CHECKING([for header that defines MAXHOSTNAMELEN])
        FOUND_MAXHOSTNAMELEN='not found'
        AC_COMPILE_IFELSE(
          AC_LANG_PROGRAM([#include <sys/param.h>],
            [int h = MAXHOSTNAMELEN;]),
          [FOUND_MAXHOSTNAMELEN='sys/param.h'
            AC_DEFINE(NEED_SYS_PARAM_H,1,
             [Define to 1 if you need <sys/param.h> to define MAXHOSTNAMELEN])])
        AC_COMPILE_IFELSE(
          AC_LANG_PROGRAM([#include <netdb.h>],
            [int h = MAXHOSTNAMELEN;]),
          [FOUND_MAXHOSTNAMELEN='netdb.h'
             AC_DEFINE(NEED_NETDB_H,1,
               [Define to 1 if you need <netdb.h> to define MAXHOSTNAMELEN])])
        AC_MSG_RESULT([$FOUND_MAXHOSTNAMELEN])
      fi
      # xrdb needs to know where to find cpp at runtime - previously set as CppCmd
      # in Imake config files for each OS
      AC_ARG_WITH([cpp], 
        AC_HELP_STRING([--with-cpp=path],
          [path to cpp command for xrdb to use at runtime]), 
        [AC_MSG_CHECKING(for cpp)
          CPP_PATH=$withval
          AC_MSG_RESULT($CPP_PATH)], 
        [AC_PATH_PROG([CPP_PATH],[cpp], [cpp], 
        [$PATH:/bin:/usr/bin:/usr/lib:/usr/libexec:/usr/ccs/lib:/usr/ccs/lbin:/lib])])
#      AC_DEFINE_UNQUOTED([CPP], "$CPP_PATH", [Path to CPP program])
      XRDB_CPP="-DCPP=\\\"$CPP_PATH\\\""

      XORGAPPS_CHECKP([xrdb], [xmuu x11], [$XRDB_CPP])
    ])
  ])

AC_DEFUN([XORGAPPS_XSET],
  [
    XORG_CHECK_PREREQ([xset], [
      XSET_MODULES="xmuu"
      if $PKG_CONFIG --exists x11 ; then
        XSET_MODULES="$XSET_MODULES x11"
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPP_FLAGS=$($PKG_CONFIG --cflags $XSET_MODULES)
        AC_CHECK_HEADERS([X11/XKBlib.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xext ; then
        XSET_MODULES="$XSET_MODULES xext"
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPP_FLAGS=$($PKG_CONFIG --cflags $XSET_MODULES)
        AC_CHECK_HEADERS([X11/extensions/dpms.h X11/extensions/MITMisc.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xxf86misc ; then
        XSET_MODULES="$XSET_MODULES xxf86misc"
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPP_FLAGS=$($PKG_CONFIG --cflags $XSET_MODULES)
        AC_CHECK_HEADERS([X11/extensions/xf86misc.h X11/extensions/xf86mscstr.h],,,
          [#include <X11/Xlib.h>
#include <X11/Xproto.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xfontcache ; then
        XSET_MODULES="$XSET_MODULES xfontcache"
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPP_FLAGS=$($PKG_CONFIG --cflags $XSET_MODULES)
        AC_CHECK_HEADERS([X11/extensions/fontcache.h X11/extensions/fontcacheP.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      if $PKG_CONFIG --exists xp ; then
        XSET_MODULES="$XSET_MODULES xp"
        SAVE_CPPFLAGS="$CPPFLAGS"
        CPP_FLAGS=$($PKG_CONFIG --cflags $XSET_MODULES)
        AC_CHECK_HEADERS([X11/extensions/Print.h],,,[#include <X11/Xlib.h>])
        CPPFLAGS="$SAVE_CPPFLAGS"
      fi

      XORGAPPS_CHECKP([xset], [$XSET_MODULES])
    ])
  ])

AC_DEFUN([XORGAPPS_XVIDTUNE],
  [
    XORGAPPS_XPRINT_CHECK([xvidtune], [xxf86vm])

    AC_ARG_WITH(vendor-name,
      AS_HELP_STRING([--with-vendor-name=VENDOR],
        [Vendor name for disclaimer statement]),
        [ VENDOR_NAME="$withval" ],
        [ VENDOR_NAME="The X.Org Foundation" ])
    AC_SUBST([VENDOR_NAME])
  ])
