AC_DEFUN([XORGDOCS_CHECK_LINUXDOC],
  [
    AC_ARG_WITH([ps_docs], AC_HELP_STRING([--with-ps-docs],
      [Make the postscript documents (default yes)]),
      [BUILDPSDOC="$withval"], [BUILDPSDOC=yes])

    AC_ARG_WITH([pdf_docs], AC_HELP_STRING([--with-pdf-docs],
      [Make the pdf documents (default yes)]),
      [BUILDPDFDOC="$withval"], [BUILDPDFDOC=yes])

    AC_ARG_WITH([html_docs], AC_HELP_STRING([--with-html-docs],
      [Make the html documents (default yes)]),
      [BUILDHTMLDOC="$withval"], [BUILDHTMLDOC=yes])

    AC_ARG_WITH([papersize], AC_HELP_STRING([--with-papersize],
      [The papersize for ps and pdf documents (default letter)]),
      [PAPERSIZE="$withval"], [PAPERSIZE=letter])

    DEFS_ENT_PATH=\$\(top_srcdir\)/sgml-doctools

    AC_PATH_PROG(LINUXDOC, linuxdoc)
    AC_MSG_CHECKING([Whether to build documentation])
    if test x$DEFS_ENT_PATH != x && test x$LINUXDOC != x ; then
      BUILDDOC=yes
    else
      BUILDDOC=no
      BUILDPSDOC=no
      BUILDPDFDOC=no
      BUILDHTMLDOC=no
    fi
    AM_CONDITIONAL(BUILD_LINUXDOC, [test x$BUILDDOC = xyes])
    AC_MSG_RESULT([$BUILDDOC])

    AC_MSG_CHECKING([Whether to build pdf documentation])
    test "x$BUILDPDFDOC" != xno && BUILDPDFDOC=yes
    AM_CONDITIONAL(BUILD_PDFDOC,  [test "x$BUILDPDFDOC" = xyes])
    AC_MSG_RESULT([$BUILDPDFDOC])

    AC_MSG_CHECKING([Whether to build postscript documentation])
    test "x$BUILDPSDOC" != xno && BUILDPSDOC=yes
    AM_CONDITIONAL(BUILD_PSDOC,  [test "x$BUILDPSDOC" = xyes])
    AC_MSG_RESULT([$BUILDPSDOC])

    if test "x$BUILDPSDOC" = xyes -o "x$BUILDPDFDOC" = xyes ; then
      AC_MSG_CHECKING([For the ps/pdf papersize])
      test "x$PAPERSIZE" = xno && PAPERSIZE=letter
      AC_MSG_RESULT([$PAPERSIZE])
    fi

    AC_MSG_CHECKING([Whether to build html documentation])
    test "x$BUILDHTMLDOC" != xno && BUILDHTMLDOC=yes
    AM_CONDITIONAL(BUILD_HTMLDOC,  [test "x$BUILDHTMLDOC" = xyes])
    AC_MSG_RESULT([$BUILDHTMLDOC])

    MAKE_TEXT="SGML_SEARCH_PATH=$DEFS_ENT_PATH GROFF_NO_SGR=y $LINUXDOC -B txt"
    MAKE_PS="SGML_SEARCH_PATH=$DEFS_ENT_PATH $LINUXDOC -B latex \
      --papersize=$PAPERSIZE --output=ps"
    MAKE_PDF="SGML_SEARCH_PATH=$DEFS_ENT_PATH $LINUXDOC -B latex \
      --papersize=$PAPERSIZE --output=pdf"
    MAKE_HTML="SGML_SEARCH_PATH=$DEFS_ENT_PATH $LINUXDOC  -B html --split=0"

    AC_SUBST([MAKE_TEXT])
    AC_SUBST([MAKE_PS])
    AC_SUBST([MAKE_PDF])
    AC_SUBST([MAKE_HTML])
  ])
