AC_DEFUN([XORGFONTS_FONTS],
  [dnl
# XORGFONTS_FONTS
    DEFAULT_XORGFONTS_LIST="$1"
    AC_ARG_WITH([fonts], [AC_HELP_STRING([--with-fonts="list"],
      [List of fonts to build (default=ALL) available fonts are - @<:@$1@:>@ Also valid is the wild card ALL-[TYPE] where [TYPE] is a whole part such as 100dpi or adobe])],
      [
        case "$withval" in
          no|NO|none|NONE)  XORGFONTS_LIST="" ;;
          yes|YES|all|ALL)  XORGFONTS_LIST="$DEFAULT_XORGFONTS_LIST" ;;
          *)                XORGFONTS_LIST="`echo $enableval | sed -n 's/,/ /g ; p'`" ;;
        esac
      ], [XORGFONTS_LIST="$DEFAULT_XORGFONTS_LIST"])
    for XOfont in $XORGFONTS_LIST ; do
      ALLVAR="`echo $XOfont | sed -n 's/all-.*/all/g ; s/ALL-.*/all/g ; p'`"
      WILDVAR="`echo $XOfont | sed 's/all-\(.*\)/\1/'`"
      if test "x$ALLVAR" = "ALL" -o "x$ALLVAR" = "all" ; then
        for XOfont2 in $DEFAULT_XORGFONTS_LIST ; do
          case "$XOfont2" in
            *${WILDVAR}*) FONTVAR="`echo XBUILD_$XOfont2 | sed -n 's/-/_/g ; p'`"
                          if eval "test \"x$FONTVAR\" != \"xno\"" ; then
                            eval ${FONTVAR}=yes
                          fi ;;
          esac
        done
      else
        FONTVAR="`echo XBUILD_$XOfont | sed -n 's/-/_/g ; p'`"
        if eval "test \"x$FONTVAR\" != \"xno\"" ; then
          eval ${FONTVAR}=yes
        fi
      fi
    done
    AC_CONFIG_COMMANDS_PRE([
      XORG_M4_FOR([
        if test "x$Underscore([XBUILD_@1])" = "xyes" ; then
          XORG_SUBDIRS="$XORG_SUBDIRS @1"
        fi
      ],[$1])
      XORG_OUTPUT_RESULTS([fonts],[util encodings alias $1])
    ])
  ])dnl
