#
# XORGLIBS_PREP_MODULES
#
AC_DEFUN([XORGLIBS_PREP_MODULES], [dnl
  Capitols([DEFAULT_XORGDIRS_$1])="$2"
  $1_module_select=ALL
  AC_ARG_ENABLE([$1_modules], AC_HELP_STRING([--enable-$1-modules=list],
    [List of $1 modules to build @<:@default = ALL@:>@ available modules are - @<:@$2@:>@]),
    [
      case "$enableval" in
        no|NO|none|NONE)  $1_modules=""
                          $1_module_select=NONE ;;
        yes|YES|all|ALL)  $1_modules="$Capitols([DEFAULT_XORGDIRS_$1])" ;;
        *)                $1_modules="RTCommas2Spaces([$enableval])"
                          $1_module_select=SELECTED ;;
      esac
    ], [$1_modules="$Capitols([DEFAULT_XORGDIRS_$1])"])
  AC_ARG_WITH([system_$1], AC_HELP_STRING([--with-system-$1=list],
    [List of system $1 modules @<:@default = NONE@:>@ available modules are - @<:@$2@:>@]),
    [
      case "$withval" in
        no|NO|none|NONE)  system_$1="" ;;
        yes|YES|all|ALL)  system_$1="$Capitols([DEFAULT_XORGDIRS_$1])" ;;
        *)                system_$1="RTCommas2Spaces([$withval])" ;;
      esac
    ], [system_$1=""])
  for XORG_SUBDIR in $$1_modules ; do
    eval RTUnderscore([XBUILD_${XORG_SUBDIR}])=yes
  done
  for XORG_SUBDIR in $system_$1 ; do
    if eval test "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xyes" -o \
                 "x$$1_module_select" = "xALL" ; then
      eval RTUnderscore([XBUILD_${XORG_SUBDIR}])="sys"
    fi
  done
  for XORG_SUBDIR in $Capitols([DEFAULT_XORGDIRS_$1]) ; do
    if eval test "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xyes" -a \
                 "x$RTUnderscore([XBUILD_${XORG_SUBDIR}])" != "xsys" ; then
      eval RTUnderscore([XBUILD_${XORG_SUBDIR}])=no
    fi
  done
  XORG_M4_FOR([AC_SUBST(Capitols([@1_VERSION]), XMOD_VERSION([@1]))], [$2])
  AC_CONFIG_COMMANDS_PRE([dnl
    XORG_OUTPUT_RESULTS([$1], [$2])
    AC_SUBST([XORG_SUBDIRS])
  ])dnl
])dnl

#
# Fix the pkg_config_path for find
#
AC_DEFUN([XORG_FIX_PKG_PATH],[dnl
PACKAGE_PATH=""
for p in `echo $PKG_CONFIG_PATH | sed 's/:/ /'` ; do
  test -d $p && PACKAGE_PATH="$PACKAGE_PATH $p"
PACKAGE_PATH="$PACKAGE_PATH `type -p $PKG_CONFIG | sed s%/bin/.*%%`/lib/pkgconfig"
done])

#
# XORG_FIND_PC - finds a particular pc file
#
AC_DEFUN([XORG_FIND_PC], [dnl
AC_REQUIRE([XORG_FIX_PKG_PATH])dnl
`for P in $PACKAGE_PATH /usr/lib/pkgconfig ; do
  if test -e ${P}/$1.pc ; then
     echo ${P}/$1.pc
     break
  fi
done`])dnl

#
# XORGLIBS_MODULES
# arg 1  - module dir
# arg 2  - module name - defaults to dir if not given
# arg 3  - module alternate Flags prefix
# arg 4  - module internal deps
# arg 5  - module internal cflags
# arg 6  - module internal libs
# arg 7  - module internal extra cflags
# arg 8  - module internal extra libs
# arg 9  - module build extra cflags
# arg 10 - module build extra libs
#
AC_DEFUN([XORGLIBS_MODULES_NO_SUBDIR],[dnl
AC_REQUIRE([PKG_PROG_PKG_CONFIG])
if test "x$Underscore([XBUILD_$1])" != "xno" ; then
  XTMP_MODULES=""
  XTMP_CFLAGS=""
  XTMP_LIBS=""
m4_if([$4], [], [], [dnl
  for MDL in $4 ; do
    if eval test "x$RTUnderscore([XBUILD_$MDL])" = "xyes" ; then
      XTMP_CFLAGS="$XTMP_CFLAGS $(eval echo $RTCapitols([${MDL}_INT_CFLAGS]))"
      XTMP_LIBS="$XTMP_LIBS $(eval echo $RTCapitols([${MDL}_INT_LIBS]))"
    elif eval test "x$RTUnderscore([XBUILD_$MDL])" = "xsys" ; then
      eval TMP_MDL="$RTUnderscore([${MDL}_MODULE])"
      if $PKG_CONFIG --silence-errors --exists $TMP_MDL ; then
        XTMP_MODULES="$XTMP_MODULES $TMP_MDL"
      else
m4_if([
        PC_FILE="XORG_FIND_PC([$TMP_MDL])"
        XTMP_PFX="$XTMP_CFLAGS `cat $PC_FILE |sed '/includedir.*/p;d' |sed 's/.*://;s/.*=//'`"
        XTMP_F="`cat $PC_FILE |sed '/Cflags:.*/p;d' |sed 's/.*://;s/.*=//'`"
        XTMP_F="`echo $XTMP_F | sed \"s%\${includedir}%$XTMP_PFX%\"`"
        XTMP_CFLAGS="$XTMP_CFLAGS $XTMP_F"
echo $XTMP_F
        XTMP_LIBS="$XTMP_LIBS `cat $PC_FILE |sed '/Libs:.*/p;d' |sed 's/.*://;s/.*=//'`"
        if test "x$PC_FILE" != "x" ; then
          for DML in `cat $PC_FILE |sed '/Require.*/p;d' |sed 's/.*://;s/.*=//'` ; do
            if eval test "x$RTUnderscore([XBUILD_$DML])" = "xyes" ; then
              XTMP_CFLAGS="$XTMP_CFLAGS $(eval echo $RTCapitols([${DML}_INT_CFLAGS]))"
              XTMP_LIBS="$XTMP_LIBS $(eval echo $RTCapitols([${DML}_INT_LIBS]))"
            elif eval test "x$RTUnderscore([XBUILD_$DML])" = "xsys" ||
                 $PKG_CONFIG --silence-errors --exists $MDL ; then
              XTMP_MODULES="$XTMP_MODULES $DML"
              XTMP_PFX="$XTMP_CFLAGS `cat $PC_FILE |sed '/includedir.*/p;d' |sed 's/.*://;s/.*=//'`"
              XTMP_CFLAGS="$XTMP_CFLAGS `cat $PC_FILE |sed '/Cflags:.*/p;d' |sed 's/.*://g;s/.*=//g;s%\${includedir}%'$XTMP_PFX'%'`"
echo $XTMP_CFLAGS
              XTMP_LIBS="$XTMP_LIBS `cat $PC_FILE |sed '/Libs:.*/p;d' |sed 's/.*://;s/.*=//'`"
            else
              XORG_DISABLE_MODULE([$1])
              break
            fi
          done
          test "x$Underscore([XBUILD_$1])" = "no" && break
        else
])
          XORG_DISABLE_MODULE([$1])
AC_MSG_WARN([$1 requires system module $TMP_MDL - not building])
          break
dnl        fi
      fi
    else
      XORG_DISABLE_MODULE([$1])
AC_MSG_WARN([$1 requires module $MDL - not building])
      break
    fi
  done
  if test "x$XTMP_MODULES" != "x" ; then
AC_MSG_CHECKING([$1 deps - $XTMP_MODULES ])
    if $PKG_CONFIG --exists "$XTMP_MODULES" ; then
      XTMP_CFLAGS="$XTMP_CFLAGS $($PKG_CONFIG --cflags $XTMP_MODULES)"
      XTMP_LIBS="$XTMP_LIBS $($PKG_CONFIG --libs $XTMP_MODULES)"
    else
      XORG_DISABLE_MODULE([$1])
    fi
AC_MSG_RESULT($Underscore([XBUILD_$1]))
  fi
])dnl
m4_if([$4$9$10], [], [], [dnl
m4_if([$3], [], [dnl
m4_if([$2], [], [dnl
  AC_SUBST(Capitols([$1_CFLAGS]), ["$XTMP_CFLAGS $9"])
  AC_SUBST(Capitols([$1_LIBS]), ["$XTMP_LIBS $10"])
], [dnl
  AC_SUBST(Capitols([$2_CFLAGS]), ["$XTMP_CFLAGS $9"])
  AC_SUBST(Capitols([$2_LIBS]), ["$XTMP_LIBS $10"])
])], [dnl
  AC_SUBST(Capitols([$3_CFLAGS]), ["$XTMP_CFLAGS $9"])
  AC_SUBST(Capitols([$3_LIBS]), ["$XTMP_LIBS $10"])
])])dnl
  if test "x$Underscore([XBUILD_$1])" = "xyes" ; then
m4_if([$5], [], [dnl
    Capitols([$1_INT_CFLAGS])="esyscmd(test -d $1/include && echo -n '-I\$(top_srcdir)/$1/include') $7"
], [dnl
    Capitols([$1_INT_CFLAGS])="$5 $7"
])dnl
    Capitols([$1_INT_LIBS])="$6 $8"
  elif test "x$Underscore([XBUILD_$1])" = "xsys" ; then
    m4_if([$2], [], [Underscore([$1_MODULE])="$1"], [Underscore([$1_MODULE])="$2"])
  fi
  m4_if([$2], [], [], [XBUILD_$2=$XBUILD_$1])
fi
])dnl

AC_DEFUN([XORGLIBS_MODULES],[dnl
XORGLIBS_MODULES_NO_SUBDIR([$1], [$2], [$3], [$4], [$5], [$6], [$7], [$8],
[$9], [$10])dnl
if test "x$Underscore([XBUILD_$1])" = "xyes" ; then
  XORG_SUBDIRS="$XORG_SUBDIRS $1"
fi
])

#
# XORG_GCC_FLAGS
#
AC_DEFUN([XORG_GCC_CFLAGS],
  [
    if test "x$GCC" = "xyes" ; then
      CFLAGS="-Wnested-externs -fno-strict-aliasing $CFLAGS"
      CFLAGS="-Wmissing-prototypes -Wmissing-declarations $CFLAGS"
      CFLAGS="-Wall -Wpointer-arith -Wstrict-prototypes $CFLAGS"
    else
      CFLAGS=""
    fi
  ])

#
# XORG_CHECK_FREETYPE
#
AC_DEFUN([XORG_CHECK_FREETYPE],
  [
    XFONT_FONTFILE=no
    AC_ARG_ENABLE(freetype, [ --disable-freetype],[XFONT_FREETYPE=$enableval],
      [XFONT_FREETYPE=yes])
    AM_CONDITIONAL(XFONT_FREETYPE, [test x$XFONT_FREETYPE = xyes])
    if test x$XFONT_FREETYPE = xyes; then
      AC_DEFINE(XFONT_FREETYPE,1,
        [Support FreeType rasterizer for nearly all font file formats])
      AC_ARG_WITH(freetype-config,
        [  --with-freetype-config=PROG   Use FreeType configuration program PROG],
        freetype_config=$withval, freetype_config=auto)

      if test "$freetype_config" = "auto" ; then
        PKG_CHECK_MODULES(FREETYPE, freetype2, freetype_config=no,
          freetype_config=yes)
      fi

      if test "$freetype_config" = "yes"; then
        AC_PATH_PROG(ft_config,freetype-config,no)
        if test "$ft_config" = "no"; then
          AC_MSG_ERROR(
            [You must have freetype installed; see http://www.freetype.org/])
        fi
      else
        ft_config="$freetype_config"
      fi

      if test "$freetype_config" != "no"; then
        FREETYPE_CFLAGS="`$ft_config --cflags`"
        FREETYPE_LIBS="`$ft_config --libs`"
      fi
      FREETYPE_REQUIRES="freetype2"
      XFONT_FONTFILE=yes
    else
      FREETYPE_CFLAGS=""
      FREETYPE_LIBS=""
      FREETYPE_REQUIRES=""
    fi
    AC_SUBST(FREETYPE_LIBS)
    AC_SUBST(FREETYPE_CFLAGS)
    AC_SUBST(FREETYPE_REQUIRES)
  ])

#
# XORG_CHECK_FONTCONFIG
#
AC_DEFUN([XORG_CHECK_FONTCONFIG],
  [
    AC_REQUIRE([XORG_CHECK_FREETYPE])
    FVER="$1"
    test "x$FVER" = "x" && FVER="2.2"
    PKG_CHECK_MODULES(FONTCONFIG, fontconfig >= $FVER)
    AC_SUBST(FONTCONFIG_CFLAGS)
    AC_SUBST(FONTCONFIG_LIBS)
    fontconfig_save_libs="$LIBS"
    fontconfig_save_cflags="$CFLAGS"
    LIBS="$LIBS $FREETYPE_LIBS"
    CFLAGS="$CFLAGS $FREETYPE_CFLAGS"
    AC_CHECK_FUNCS(FT_Get_Next_Char FT_Get_BDF_Property FT_Get_PS_Font_Info FT_Has_PS_Glyph_Names FT_GlyphSlot_Embolden)
    AC_CHECK_MEMBER(FT_Bitmap_Size.y_ppem,
                    HAVE_FT_BITMAP_SIZE_Y_PPEM=1,
                    HAVE_FT_BITMAP_SIZE_Y_PPEM=0,
    [#include <ft2build.h>
    #include FT_FREETYPE_H])
    AC_DEFINE_UNQUOTED(HAVE_FT_BITMAP_SIZE_Y_PPEM,$HAVE_FT_BITMAP_SIZE_Y_PPEM,
                   [FT_Bitmap_Size structure includes y_ppem field])
    LIBS="$fontconfig_save_libs"
    CFLAGS="$fontconfig_save_cflags"
  ])

#
# XORG_XPOLL_H
#
AC_DEFUN([XORG_XPOLL_H],
  [
    fds_bits_found=false;
    if test "x$fds_bits_found" = xfalse ; then
      AC_CHECK_MEMBER(fd_set.fds_bits,
        [
          fds_bits_found=plain
          USE_FDS_BITS="fds_bits"
        ],,
        [
          #include <sys/types.h>
          #include <sys/select.h>
       ])
    fi
    if test "x$fds_bits_found" = xfalse ; then
      AC_CHECK_MEMBER(fd_set.__fds_bits,
        [
          fds_bits_found=underscores
          USE_FDS_BITS="__fds_bits"
        ],,
        [
          #include <sys/types.h>
          #include <sys/select.h>
        ])
    fi
    if test "x$fds_bits_found" = xfalse ; then
      AC_MSG_ERROR([Could not determine how to access the fds_bits or equivalent
		structure in fd_set on your platform.])
    fi
    AC_SUBST([USE_FDS_BITS])
  ])

#
# XORG_XFUNCPROTO_H
#
AC_DEFUN([XORG_XFUNCPROTO_H],
  [
    AC_REQUIRE([AC_CANONICAL_HOST])
    AC_MSG_CHECKING([whether const prototypes are supported])
    if test "x$CONSTPROTO" = xauto; then
      case $host_os in
        linux*|freebsd*|netbsd*|openbsd*|solaris*)  CONSTPROTO=yes ;;
        *)                                          CONSTPROTO=no ;;
      esac
    fi
    AC_MSG_RESULT([$CONSTPROTO])
    AC_MSG_CHECKING([whether varargs prototypes are supported])
    if test "x$VAPROTO" = xauto; then
      case $host_os in
        linux*|freebsd*|netbsd*|openbsd*|solaris*)  VAPROTO=yes ;;
        *)                                          VAPROTO=no ;;
      esac
    fi
    AC_MSG_RESULT([$VAPROTO])
    AC_MSG_CHECKING([whether nested prototypes are supported])
    if test "x$NESTEDPROTO" = xauto; then
      case $host_os in
        linux*|freebsd*|netbsd*|openbsd*|solaris*)  NESTEDPROTO=yes ;;
        *)                                          NESTEDPROTO=no ;;
      esac
    fi
    AC_MSG_RESULT([$NESTEDPROTO])
    AC_MSG_CHECKING([whether to force function prototypes])
    if test "x$FUNCPROTO" = xauto; then
      case $host_os in
        linux*|freebsd*|netbsd*|openbsd*)   FUNCPROTO=yes ;;
        *)          if test "x$VAPROTO" = xyes && test "x$NESTEDPROTO" = xyes; then
                        FUNCPROTO=yes
                    else
                        FUNCPROTO=no
                    fi
                    ;;
      esac
    fi
    AC_MSG_RESULT([$FUNCPROTO])
# Logic for this was taken from Imake.tmpl
    if test "x$FUNCPROTO" = xyes && test "x$VAPROTO" = xyes && \
        test "x$NESTEDPROTO" = xyes && test "x$CONSTPROTO" = xyes; then
      AC_DEFINE(FUNCPROTO, [15], [FUNCPROTO])
    else
      if test "x$FUNCPROTO" = xyes && test "x$VAPROTO" = xyes && \
          test "x$NESTEDPROTO" = xyes; then
        AC_DEFINE(FUNCPROTO, [11], [FUNCPROTO])
      else
        if test "x$FUNCPROTO" = xyes && test "x$NESTEDPROTO" = xyes; then
          AC_DEFINE(FUNCPROTO, [9], [FUNCPROTO])
        else
          if test "x$FUNCPROTO" = xyes && test "x$VAPROTO" = xyes && \
              test "x$CONSTPROTO" = xyes; then
            AC_DEFINE(FUNCPROTO, [7], [FUNCPROTO])
          else
            if test "x$FUNCPROTO" = xyes && test "x$CONSTPROTO" = xyes; then
              AC_DEFINE(FUNCPROTO, [5], [FUNCPROTO])
            else
              if test "x$FUNCPROTO" = xyes && test "x$VAPROTO" = xyes; then
                AC_DEFINE(FUNCPROTO, [3], [FUNCPROTO])
              else
                if test "x$FUNCPROTO" = xyes; then
                  AC_DEFINE(FUNCPROTO, [], [FUNCPROTO])
                fi
              fi
            fi
          fi
        fi
      fi
    fi
    AC_MSG_CHECKING([whether to widen function prototypes])
    if test "x$WIDEPROTO" = xauto; then
      case $host_os in
        linux*|freebsd*|netbsd*|openbsd*)   WIDEPROTO=no ;;
        *)                                  WIDEPROTO=yes ;;
      esac
    fi
    AC_MSG_RESULT([$WIDEPROTO])
    if test "x$WIDEPROTO" = xno; then
      AC_DEFINE(NARROWPROTO, [], [Narrow prototypes])
    fi
  ])

#
#  XORG_SUBDIR_VERSION
#
AC_DEFUN([XORG_SUBDIR_VERSION],
  [
    AC_SUBST(APPLEWMPROTO_VERSION, `cat $srcdir/applewmproto/version`)
    AC_SUBST(BIGREQSPROTO_VERSION, `cat $srcdir/bigreqsproto/version`)
    AC_SUBST(COMPOSITEPROTO_VERSION, `cat $srcdir/compositeproto/version`)
    AC_SUBST(DAMAGEPROTO_VERSION, `cat $srcdir/damageproto/version`)
    AC_SUBST(DMXPROTO_VERSION, `cat $srcdir/dmxproto/version`)
    AC_SUBST(EVIEEXT_VERSION, `cat $srcdir/evieext/version`)
    AC_SUBST(FIXESPROTO_VERSION, `cat $srcdir/fixesproto/version`)
    AC_SUBST(FONTCACHEPROTO_VERSION, `cat $srcdir/fontcacheproto/version`)
    AC_SUBST(FONTSPROTO_VERSION, `cat $srcdir/fontsproto/version`)
    AC_SUBST(GLPROTO_VERSION, `cat $srcdir/glproto/version`)
    AC_SUBST(INPUTPROTO_VERSION, `cat $srcdir/inputproto/version`)
    AC_SUBST(KBPROTO_VERSION, `cat $srcdir/kbproto/version`)
    AC_SUBST(PRINTPROTO_VERSION, `cat $srcdir/printproto/version`)
    AC_SUBST(RANDRPROTO_VERSION, `cat $srcdir/randrproto/version`)
    AC_SUBST(RECORDPROTO_VERSION, `cat $srcdir/recordproto/version`)
    AC_SUBST(RENDERPROTO_VERSION, `cat $srcdir/renderproto/version`)
    AC_SUBST(RESOURCEPROTO_VERSION, `cat $srcdir/resourceproto/version`)
    AC_SUBST(SCRNSAVERPROTO_VERSION, `cat $srcdir/scrnsaverproto/version`)
    AC_SUBST(TRAPPROTO_VERSION, `cat $srcdir/trapproto/version`)
    AC_SUBST(VIDEOPROTO_VERSION, `cat $srcdir/videoproto/version`)
    AC_SUBST(WINDOWSWMPROTO_VERSION, `cat $srcdir/windowswmproto/version`)
    AC_SUBST(XCMISCPROTO_VERSION, `cat $srcdir/xcmiscproto/version`)
    AC_SUBST(XEXTPROTO_VERSION, `cat $srcdir/xextproto/version`)
    AC_SUBST(XF86BIGFONTPROTO_VERSION, `cat $srcdir/xf86bigfontproto/version`)
    AC_SUBST(XF86DGAPROTO_VERSION, `cat $srcdir/xf86dgaproto/version`)
    AC_SUBST(XF86DRIPROTO_VERSION, `cat $srcdir/xf86driproto/version`)
    AC_SUBST(XF86MISCPROTO_VERSION, `cat $srcdir/xf86miscproto/version`)
    AC_SUBST(XF86RUSHPROTO_VERSION, `cat $srcdir/xf86rushproto/version`)
    AC_SUBST(XF86VIDMODEPROTO_VERSION, `cat $srcdir/xf86vidmodeproto/version`)
    AC_SUBST(XINERAMAPROTO_VERSION, `cat $srcdir/xineramaproto/version`)
    AC_SUBST(XPROTO_VERSION, `cat $srcdir/xproto/version`)
    AC_SUBST(XPROXYMANAGEMENTPROTOCOL_VERSION, `cat $srcdir/xproxymanagementprotocol/version`)
    AC_SUBST(XTRANS_VERSION, `cat $srcdir/xtrans/version`)
    AC_SUBST(XAU_VERSION, `cat $srcdir/libXau/version`)
    AC_SUBST(XDMCP_VERSION, `cat $srcdir/libXdmcp/version`)
    AC_SUBST(X11_VERSION, `cat $srcdir/libX11/version`)
    AC_SUBST(XEXT_VERSION, `cat $srcdir/libXext/version`)
    AC_SUBST(APPLEWM_VERSION, `cat $srcdir/libAppleWM/version`)
    AC_SUBST(WINDOWSWM_VERSION, `cat $srcdir/libWindowsWM/version`)
    AC_SUBST(DMX_VERSION, `cat $srcdir/libdmx/version`)
    AC_SUBST(FONTENC_VERSION, `cat $srcdir/libfontenc/version`)
    AC_SUBST(FS_VERSION, `cat $srcdir/libFS/version`)
    AC_SUBST(ICE_VERSION, `cat $srcdir/libICE/version`)
    AC_SUBST(LBXUTIL_VERSION, `cat $srcdir/liblbxutil/version`)
    AC_SUBST(OLDX_VERSION, `cat $srcdir/liboldX/version`)
    AC_SUBST(SM_VERSION, `cat $srcdir/libSM/version`)
    AC_SUBST(XT_VERSION, `cat $srcdir/libXt/version`)
    AC_SUBST(XMU_VERSION, `cat $srcdir/libXmu/version`)
    AC_SUBST(XP_VERSION, `cat $srcdir/libXp/version`)
    AC_SUBST(XAW_VERSION, `cat $srcdir/libXaw/version`)
    AC_SUBST(XFIXES_VERSION, `cat $srcdir/libXfixes/version`)
    AC_SUBST(XCOMPOSITE_VERSION, `cat $srcdir/libXcomposite/version`)
    AC_SUBST(XRENDER_VERSION, `cat $srcdir/libXrender/version`)
    AC_SUBST(XDAMAGE_VERSION, `cat $srcdir/libXdamage/version`)
    AC_SUBST(XCURSOR_VERSION, `cat $srcdir/libXcursor/version`)
    AC_SUBST(XEVIE_VERSION, `cat $srcdir/libXevie/version`)
    AC_SUBST(XFONT_VERSION, `cat $srcdir/libXfont/version`)
    AC_SUBST(XFONTCACHE_VERSION, `cat $srcdir/libXfontcache/version`)
    AC_SUBST(XFT_VERSION, `cat $srcdir/libXft/version`)
    AC_SUBST(XI_VERSION, `cat $srcdir/libXi/version`)
    AC_SUBST(XINERAMA_VERSION, `cat $srcdir/libXinerama/version`)
    AC_SUBST(XKBFILE_VERSION, `cat $srcdir/libxkbfile/version`)
    AC_SUBST(XBUI_VERSION, `cat $srcdir/libxkbui/version`)
    AC_SUBST(XPRINTUTIL_VERSION, `cat $srcdir/libXprintUtil/version`)
    AC_SUBST(XPRINTAPPUTIL_VERSION, `cat $srcdir/libXprintAppUtil/version`)
    AC_SUBST(XRANDR_VERSION, `cat $srcdir/libXrandr/version`)
    AC_SUBST(XRES_VERSION, `cat $srcdir/libXres/version`)
    AC_SUBST(XSCRNSAVER_VERSION, `cat $srcdir/libXScrnSaver/version`)
    AC_SUBST(XTRAP_VERSION, `cat $srcdir/libXTrap/version`)
    AC_SUBST(XTST_VERSION, `cat $srcdir/libXtst/version`)
    AC_SUBST(XV_VERSION, `cat $srcdir/libXv/version`)
    AC_SUBST(XVMC_VERSION, `cat $srcdir/libXvMC/version`)
    AC_SUBST(XXF86DGA_VERSION, `cat $srcdir/libXxf86dga/version`)
    AC_SUBST(XXF86MISC_VERSION, `cat $srcdir/libXxf86misc/version`)
    AC_SUBST(XXF86VM_VERSION, `cat $srcdir/libXxf86vm/version`)
  ])
